/*	
 *	clipmath.h
 *
 *	꾮饤֥ޤ
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Sat Dec  1 07:12:31 JST 2001 Naoyuki Sawa
 *	- ϡ
 */
#ifndef __CLIP_MATH_H__
#define __CLIP_MATH_H__

/*****************************************************************************
 *	
 *****************************************************************************/

#define PI	3.14159265358979323846F	/*  */
#define PI2	(PI * 2)		/* 2 */
#define PI_2	(PI / 2)		/* /2 */

/*****************************************************************************
 *	꾮
 *****************************************************************************/

/* 꾮˴ؤޥؿϡä¿ѤȻפΤǡ
 * ̾Υ͡ߥ󥰵§˽äץե"fixed_"ǤϤʤ
 * ñʸΥץե"F"Ϳޤ
 */

/* 꾮ɽޤ
 * ӥåȷϡ̤Ǥ
 *	iiiiiiii_iiffffff
 *	|||||||| ||++++++- (unsigned)
 *	++++++++---------- (  signed)
 */
typedef short FIXED;

/* * FIXED_SHIFTˤꡢͤϰϡ٤ϼΤ褦ˤʤޤ
 *	+-----------+--------------+------------+
 *	|FIXED_SHIFT| ϰ ||
 *	+-----------+--------------+------------+
 *	|     0     |-32768+32767|    1/  1   |
 *	|     1     |-16384+16383|    1/  2   |
 *	|     2     |- 8192+ 8191|    1/  4   |
 *	|     3     |- 4096+ 4095|    1/  8   |
 *	|     4     |- 2048+ 2047|    1/ 16   |
 *	|     5     |- 1024+ 1023|    1/ 32   |
 *	|     6     |-  512+  511|    1/ 64   |
 *	|     7     |-  256+  255|    1/128   |
 *	+-----------+--------------+------------+
 * * ߤΥץFIXED_SHIFT=07Ǥ뤳Ȥ˰¸ƤΤǡ
 *   FIXED_SHIFT8ʾͤꤷƤϤޤ
 */
#define FIXED_SHIFT	6			/* Υӥåȿ */
#define FIXED_SCALE	(1 << FIXED_SHIFT)	/* 꾮 */

/* 꾮<->ưѴԤޤ
 * * F(a)ΰaˤϡưɤǤǤޤ
 * * Fint(a)Ffloat(a)ϡa򤤤ä(FIXED)˥㥹ȤƤޤ
 *   F(a)ΰaˤϡưɤǤǤͤʤΤǡ
 *   a򥭥㥹ȤˤΤޤ޻ȤäƤޤ
 */
#define F(a)		((FIXED)((a) * FIXED_SCALE))
#define Fint(a)		((FIXED)(a) >> FIXED_SHIFT)
#define Ffloat(a)	((float)(FIXED)(a) / FIXED_SCALE)

/* Ѥߤθ꾮ͤǤ
 */
#define F1		F(1)
/* ߼ΨϡΤ
 *	FPI_2 -(2)-> FPI -(2)-> FPI2
 * Ȥʤ褦ˡFPI_2ơܡܤޤ
 * ⤷ñ
 *	#define FPI F(PI)
 *	#define FPI2 F(PI2)
 *	#define FPI_2 F(PI_2)
 * ȤƤޤȡFPI24ܿǤʤä˸
 * Ѵؿ礭ʱƶФƤޤޤ(ºݡʤޤ)
 */
#define FPI_2		F(PI_2)
#define FPI		(FPI_2 * 2)
#define FPI2		(FPI   * 2)

/* ͤޤ
 * ˡƱʤΤǡstdlib.hˤabs()ؿȤޤ
 * ץबɤߤ䤹褦ˡFؿȤ뤳Ȥˤޤ
 */
#define Fabs(a)		((FIXED)(a) >= 0 ? (FIXED)(a) : -(FIXED)(a))

/* 꾮ƱΤξԤޤ
 * * 꾮ȿž꾮ƱΤβø꾮ξϡ
 *   ̾μǷ׻ǤΤǡα黻ǽϥޥƤޤ
 *   øޥʤäͳϡɤ߰פͥ褷Ǥ
 * * 꾮κ缰¿Ѥȡϰ츫ɤ߰פƤ⡢
 *   ץबäƤ뤫򤷤Ť餯ʤΤǡդɬפǤ
 *   Ǥ꾮ƱΤη׻ȤƤ
 * * ̾μȥޥΤɤȤϡʲɽ򻲾ȤƤ
 *	+----------+-------+-------+---------+------------+
 *	|          |   |   |     |        |
 *	+----------+-------+-------+---------+------------+
 *	|op|a+b    |a-b    |Fmul(a,b)|Fdiv(a,b)   |
 *	|op|a+F(b) |a-F(b) |a*b      |a/b         |
 *	|op|F(a)+b |F(a)- b|a*b      |Fdiv(F(a),b)|
 *	+----------+-------+-------+---------+------------+
 */
#define Fmul(a, b)	((FIXED)(a) * (FIXED)(b) >> FIXED_SHIFT)
#define Fdiv(a, b)	(((FIXED)(a) << FIXED_SHIFT) / (FIXED)(b))
#define Fmul3(a, b, c)	Fmul(Fmul(a, b), c)
#define Fdiv3(a, b, c)	Fdiv(Fdiv(a, b), c)

/* 꾮εտ(inversed number)ޤ
 */
#define Finv(a)		Fdiv(F1, a)

/* 꾮ʿʿ׻ޤ
 */
#define Fsqu(a)		Fmul(a, a)
FIXED Fsqrt(FIXED a);

/* 꾮λѴؿ׻ޤ
 */
FIXED Fsin(FIXED a);
FIXED Fcos(FIXED a);
FIXED Ftan(FIXED a);
FIXED Fasin(FIXED a);
FIXED Facos(FIXED a);
FIXED Fatan(FIXED a);
FIXED Fatan2(FIXED a);

/*****************************************************************************
 *	٥ȥ
 *****************************************************************************/

/* ٥ȥ˴ؤޥؿϡä¿ѤȻפΤǡ
 * ̾Υ͡ߥ󥰵§˽äץե"vector_"ǤϤʤ
 * ñʸΥץե"V"Ϳޤ
 */

/* ٥ȥɽޤ
 */
typedef struct _VECTOR {
	FIXED x;	/* Xʬ */
	FIXED y;	/* Yʬ */
	FIXED z;	/* Zʬ */
} VECTOR;

/* ѤߤΥ٥ȥǤ
 */
extern const VECTOR V0;	/* ٥ȥ */
extern const VECTOR VX;	/* Xñ̥٥ȥ */
extern const VECTOR VY;	/* Yñ̥٥ȥ */
extern const VECTOR VZ;	/* Zñ̥٥ȥ */

/* ٥ȥޤ
 * [in]
 *	x,y,z		X,Y,Zʬ͡
 * [out]
 *			٥ȥ롣
 */
VECTOR V(FIXED x, FIXED y, FIXED z);

/* ٥ȥγʬȿžޤ
 * [in]
 *	a		ȿž٥ȥ롣
 * [out]
 *			ȿž٥ȥ롣
 */
VECTOR Vneg(VECTOR a);

/* ٥ȥγʬûޤ
 * [in]
 *	a,b		û٥ȥ롣
 * [out]
 *			̤Υ٥ȥ롣
 */
VECTOR Vadd(VECTOR a, VECTOR b);

/* ٥ȥγʬ򸺻ޤ
 * [in]
 *	a,b		٥ȥ롣
 * [out]
 *			̤Υ٥ȥ롣
 */
VECTOR Vsub(VECTOR a, VECTOR b);

/* ٥ȥγʬ軻ޤ
 * [in]
 *	a,b		軻٥ȥ롣
 * [out]
 *			̤Υ٥ȥ롣
 */
VECTOR Vmul(VECTOR a, VECTOR b);

/* ٥ȥγʬޤ
 * [in]
 *	a,b		٥ȥ롣
 * [out]
 *			̤Υ٥ȥ롣
 */
VECTOR Vdiv(VECTOR a, VECTOR b);

/* ٥ȥγʬƱͤǾ軻ޤ
 * [in]
 *	a		軻٥ȥ롣
 *	b		軻͡
 * [out]
 *			̤Υ٥ȥ롣
 */
VECTOR Vmul1(VECTOR a, FIXED b);

/* ٥ȥγʬƱͤǽޤ
 * [in]
 *	a		٥ȥ롣
 *	b		͡
 * [out]
 *			̤Υ٥ȥ롣
 */
VECTOR Vdia(VECTOR a, FIXED b);

/* ٥ȥ(dot product)ޤ
 * [in]
 *	a,b		Ѥ٥ȥ롣
 * [out]
 *			Ѥ͡
 * [note]
 * 	* Ѥ: ab = |a||b|cos
 */
FIXED Vdot(VECTOR a, VECTOR b);

/* ٥ȥγ(cross product)ޤ
 * [in]
 *	a,b		Ѥ٥ȥ롣
 * [out]
 *			ѤΥ٥ȥ롣
 * [note]
 * 	* Ѥ: ab = |a||b|sin*c
 * 	  cab˿ľñ̥٥ȥȤ롣
 */
VECTOR Vcross(VECTOR a, VECTOR b);

/* ٥ȥ(normalize)ޤ
 * [in]
 *	a		٥ȥ롣
 * [out]
 *			̤Υ٥ȥ롣
 */
VECTOR Vnormal(VECTOR a);

/* ٥ȥĹ(magnitude)ޤ
 * [in]
 *	a		Ĺ٥ȥ롣
 * [out]
 * 			̤͡
 */
FIXED Vmag(VECTOR a);

/* ٥ȥĹ(square magnitude)ޤ
 * [in]
 *	a		Ĺ٥ȥ롣
 * [out]
 * 			̤͡
 */
FIXED Vmag2(VECTOR a);

/* ȿͥ٥ȥޤ
 * [in]
 *	N		ȿ̤ˡ٥ȥ롣
 *	E		ȿؤΥ٥ȥ롣
 *			ȡոθ٥ȥǤ
 * [out]
 *			vout˻ꤷͤ򤽤Τޤ֤ޤ
 * [note]
 *	* ȿͥ٥ȥθϡ̤Ǥ
 *		R = 2(EN)N - E
 *	  ͤ:
 *	  ٥ȥE,NƱĤȤơENؿ򲼤硢
 *	  οNȸP
 *		P = (EN)N
 *	  Ǥʤʤ顢(EN)ϥ٥ȥE,NΤʤƤcosͤǤ
 *	  RϡPEоΤʰ֡ʤ
 *	  E顢E->Pܿʤ֤Ǥ
 *		R = E + 2(P - E)
 *		  = 2P - E
 *		  = 2(EN)N - E
 *	  ʾǤ
 *	* ٥ȥE,NϡƤʤФޤ
 *	  Ƥʤ硢ְä̤Ȥʤޤ
 *	  ºݤˤϡEƤʤϡ
 *	    ñ˷̤Υ٥ȥ礭EʤΤ褦˻פޤ
 *	    (̤ǧ)
 *	* ٥ȥEϡ"ո"٥ȥǤ뤳ȤդƤ
 *	  δؿϡȿͥ٥ȥȸ⡢
 *	  NȤơEоΤʥ٥ȥ롢ȸäΤǤ
 *	  E٥ȥƱ˼äȤ䤹ȻפΤǤ
 *	  ȤƵոŪʤ褦ʤΤǡʤäƤߤޤ
 */
VECTOR Vreflect(VECTOR N, VECTOR E);

/*****************************************************************************
 *	
 *****************************************************************************/

/* ˴ؤޥؿϡä¿ѤȻפΤǡ
 * ̾Υ͡ߥ󥰵§˽äץե"matrix_"ǤϤʤ
 * ñʸΥץե"M"Ϳޤ
 */

/* ɽޤ
 */
typedef struct _MATRIX {
	FIXED e00, e01, e02;	/* ٥ȥXʬ */
	FIXED e10, e11, e12;	/* ٥ȥYʬ */
	FIXED e20, e21, e22;	/* ٥ȥZʬ */
	FIXED e30, e31, e32;	/* ¹԰ưʬ */
} MATRIX;

/* ѤߤιǤ
 */
extern const MATRIX MI;	/* ñ(identity) */

/* ޤ
 * [in]
 *	e00,e01,e02	٥ȥXʬ
 *	e10,e11,e12	٥ȥYʬ
 *	e20,e21,e22	٥ȥZʬ
 *	e30,e31,e32	ʿ԰ưʬ
 * [out]
 *			
 */
MATRIX M(FIXED e00, FIXED e01, FIXED e02,
	 FIXED e10, FIXED e11, FIXED e12,
	 FIXED e20, FIXED e21, FIXED e22,
	 FIXED e30, FIXED e31, FIXED e32);
 
/* ž(transpose)ޤ
 * [in]
 *	a		ž֤
 * [out]
 *			̤ι
 * [note]
 *	* ʿ԰ưʬϽ졢(0,0,0)Ȥʤޤ
 */
MATRIX Mxpose(MATRIX a);

/* չ(inverse)ޤ
 * [in]
 *	a		չ
 * [out]
 *			̤ι
 * [note]
 *	* Բĵդʹꤷư̤Ǥ
 *	  ߤμǤϡ餯0顼Ȥʤޤ
 */
MATRIX Minv(MATRIX a);

/* ľ(normalized orthogonal)εչޤ
 * [in]
 *	a		չ
 * [out]
 *			̤ι
 * [note]
 *	* Minv()⡢®Ǥ
 *	* ľǤʤꤷη̤ϡ̤Ǥ
 */
MATRIX Minvno(MATRIX a);

/* ٥ȥѴ(transform)ޤ
 * [in]
 *	a		Ѵ٥ȥ롣
 *	b		Ѵ
 * [out]
 *			̤Υ٥ȥ롣
 */
VECTOR Vxform(VECTOR a, MATRIX b);

/* Ѵ(transform)ޤ
 * [in]
 *	a		Ѵ
 *	b		Ѵ
 * [out]
 *			̤ι
 */
MATRIX Mxform(MATRIX a, MATRIX b);

/*  ʿ԰ư(translate)ޤ
 * [in]
 *	x,y,z		X,Y,Zʿ԰ưʬ
 * [out]
 *			
 */
MATRIX Mxlate(FIXED x, FIXED y, FIXED z);

/* 硦̾(scale)ޤ
 * [in]
 *	x,y,z		X,Y,Zγ硦̾
 * [out]
 *			
 */
MATRIX Mscale(FIXED x, FIXED y, FIXED z);

/* X,Y,ZȤƱǡ硦̾ޤ
 * [in]
 *	a		硦̾
 * [out]
 *			
 */
MATRIX Mscale1(FIXED a);

/* Ǥռž(rotate)ޤ
 * [in]
 *	x,y,z		žΥ٥ȥ롣
 *	a		ž١
 * [out]
 *			
 * [note]
 *	* žΥ٥ȥϡƤʤƤ⹽ޤ
 */
MATRIX Mrot(FIXED x, FIXED y, FIXED z, FIXED a);

/* 켴ž(rotate)ޤ
 * [in]
 *	a		ž١
 * [out]
 *			
 */
MATRIX Mrotx(FIXED a);
MATRIX Mroty(FIXED a);
MATRIX Mrotz(FIXED a);

/* 󼴲ž(rotate)ޤ
 * [in]
 *	a,b,c		ž١
 * [out]
 *			
 */
MATRIX Mrotxyx(FIXED a, FIXED b, FIXED c);
MATRIX Mrotxzx(FIXED a, FIXED b, FIXED c);
MATRIX Mrotyxy(FIXED a, FIXED b, FIXED c);
MATRIX Mrotyzy(FIXED a, FIXED b, FIXED c);
MATRIX Mrotzxz(FIXED a, FIXED b, FIXED c);
MATRIX Mrotzyz(FIXED a, FIXED b, FIXED c);

/* 껰ž(rotate)ޤ
 * [in]
 *	a,b,c		ž١
 * [out]
 *			
 */
MATRIX Mrotxyz(FIXED a, FIXED b, FIXED c);
MATRIX Mrotxzy(FIXED a, FIXED b, FIXED c);
MATRIX Mrotyxz(FIXED a, FIXED b, FIXED c);
MATRIX Mrotyzx(FIXED a, FIXED b, FIXED c);
MATRIX Mrotzxy(FIXED a, FIXED b, FIXED c);
MATRIX Mrotzyx(FIXED a, FIXED b, FIXED c);

/* žΥ٥ȥȡž٤ޤ
 * [in]
 *	a		Ĵ٤
 *	v		žΥ٥ȥѿؤΥݥ󥿡
 * [out]
 *			ž١
 */
FIXED Mrotget(MATRIX a, VECTOR* v);

/* (orientate)ޤ
 * [in]
 *	dx,dy,dz	Zλ٥ȥ롣
 *	ux,uy,uz	Yλ٥ȥ롣
 * [out]
 *			
 * [note]
 *	* ٥ȥϡƤʤƤ⹽ޤ
 */
MATRIX Morient(FIXED dx, FIXED dy, FIXED dz,
	       FIXED ux, FIXED uy, FIXED uz);

/* Ѵޤ
 * [in]
 *	ex,ey,ez	ɸ
 *	cx,cy,cz	ɸ
 *	bank		Х󥯳
 * [out]
 *			
 */
MATRIX Mlookat(FIXED ex, FIXED ey, FIXED ez,
	       FIXED cx, FIXED cy, FIXED cz,
	       FIXED bank);

/* Ʃ(frustum)ޤ
 * [in]
 *	width		̤              (ºɸ)
 *	height		̤ι⤵            (ºɸ)
 *	front		եȥåԥ󥰵Υ(ºɸ)
 * [out]
 *			
 * [note]
 *	* ƩѴǤϤʤZɸϼºɸΤޤѲޤ
 *	  ʤʤ顢Υ饤֥ǤϹ3x4ɽƤΤǡ
 *	  ZɸθƩѴɽʤǤ
 *	  zХåեǤϤʤzåפꤷƤΤǡ
 *	  ѾϤʤȻפޤ
 *	* ιǺɸѴǤϡX,Yɸޤ
 *	  x=x/z,y=y/z Ԥäơx,y(-1,1)Ƥɬפޤ
 */
MATRIX Mfrustum(FIXED width, FIXED height, FIXED front);

/* Ʃ(perspect)ޤ
 * [in]
 *	fovy		ľ١
 *	aspect		ڥ(⤵)
 *	front		եȥåԥ󥰵Υ(ºɸ)
 * [out]
 *			
 * [note]
 *	* Mfrustum()ΥȤ򻲾ȤƤ
 */
MATRIX Mperspect(FIXED fovy, FIXED aspect, FIXED front);

/* ӥ塼ݡѴ(viewport)ޤ
 * [in]
 *	left,top	ӥ塼ݡȸɸ(꡼ɸ)
 *	width,height	ӥ塼ݡȥ  (꡼ɸ)
 *			ϸ꾮ǤϤʤǤ뤳Ȥ
 *			  դƤ
 * [out]
 *			
 * [note]
 *	* ƩѴ -> x=x/z,y=y/z -> ӥ塼ݡѴ
 *	  νŬѤϡMviewport()ȤäƤ
 *	* ƩѴ -> ӥ塼ݡѴ -> x=x/z,y=y/z
 *	  νŬѤϡMviewportz()ȤäƤ
 *	* Mviewport()ȤäɸѴμϡΤȤǤ
 *		1. T = ǥѴ * Ѵ * ƩѴ ˤɸѴ
 *		2. Zåԥ
 *		3. x = x / z, y = y / z
 *		4. T = ӥ塼ݡѴ ˤɸѴ
 *		5. XYåԥ
 *	* ФMviewportz()Ȥäϡ
 *		1. T = ǥѴ * Ѵ * ƩѴ * ӥ塼ݡѴ
 *	  	   ˤ롢ɸѴ
 *		2. Zåԥ
 *		3. x = x / z, y = y / z
 *		4. XYåԥ
 *	  Ȥʤꡢĸ餹ȤǤޤ
 */
MATRIX Mviewport(int left, int top, int width, int height);
MATRIX Mviewportz(int left, int top, int width, int height);

/* ƹޤ
 * [in]
 *	Lx,Ly,Lz	٥ȥ
 *	Gx,Gy,Gz	̾ΰ(Ǥ)κɸ
 *	Nx,Ny,Nz	̤ˡ٥ȥ
 */
MATRIX Mshadow(FIXED Lx, FIXED Ly, FIXED Lz,
	       FIXED Gx, FIXED Gy, FIXED Gz,
	       FIXED Nx, FIXED Ny, FIXED Nz);

/* ٥(ΰʬ)׻ޤ
 * [in]
 *	t	ѥȥåѿ(01)
 *	Q0	ȥݥ#0κɸ
 *	Q1	                    #1
 *	Q2	                    #2
 * [out]
 *		P(t)κɸ
 * [note]
 *	* ȥݥ->󥫡ݥȤȸƤ֤Τ? (̤ǧ)
 */
FIXED Fbezier(FIXED t, FIXED Q0, FIXED Q1, FIXED Q2);

/* ߡȶ(ΰʬ)׻ޤ
 * [in]
 *	t	ѥȥåѿ(01)
 *	Q0	ȥݥ#0κɸ
 *	Q1	                    #1
 *	Q0d	ȥݥ#0ˤ٥ȥ
 *	Q1d	                    #1
 * [out]
 *		P(t)κɸ
 * [note]
 *	* ߡȶϡ٥ȥ礭ˤäѲޤ
 *	  Ĥޤꡢ٥ȥ礭ˤ̣뤿ᡢ
 *	  ̵٥ȥƤϤޤ
 *	* δؿϡʬ׻ޤ
 *	  㤨С3ŬѤϡ3ȤäƤ
 *	* ǡȤƥȥݥȤκɸꡢ
 *	  ٥ȥ뤬ʤȤϡΤ褦ˤƤ
 *		Qnˤ٥ȥ = Qn' = a * (Q(n+1) - Q(n-1))
 *		aǤդ0.5夬Ū? (̤ǧ)
 *	  ʤ٥ȥᡢ˰򤫤ޤ
 *	* ɸ=оݡ٥ȥ=оݤѲΨ ȤߤʤС
 *	  ʳˤѤǤޤ
 */
FIXED Fhermite(FIXED t, FIXED Q0, FIXED Q1, FIXED Q0d, FIXED Q1d);

#if 0
/* ޷¦ˤ뤫¦ˤ뤫Ĵ٤ޤ
 * [in]
 *	px, py		Ĵ٤κɸ
 *	points		޷ĺꥹ
 *	n_points	ĺο3̤ꤹȡȤޤ
 * [out]
 *			¦ʤ顢0ʳ֤ͤޤ
 *			¦ʤ顢0        ֤ޤ
 * [note]
 *	* ޷ϡ̷ǤʤˤбƤޤ
 *	* ޷դ򺹤硢ȴο޷ȸʤޤ
 *	  XSetFillRules()㤨ʤСEvenOddRuleޤ
 *	  WindingRuleǤΥåˡϡߤΤȤ󶡤Ƥޤ
 */
int mxv_point_in_polygon(float px, float py, float points[/*n_points*/][2], int n_points);

/* ľؿ򲼤֤Ρľѥ᡼ޤ
 * [in]
 *	p	κɸ
 *	a	ľλɸ
 *	da	ľΥ٥ȥ
 * [out]
 *		ľ˿ꤿ֤ɽľѥ᡼
 * [note]
 *	* ľȾľȸʤ硢Ⱦľ˲ꤿȽꤹˤ:
 *		daȾľΤΤӤؤΥ٥ȥȤsᡢ
 *			0 <= s
 *		ʤȾľ˿롣
 *	* ľʬȸʤ硢ʬ˲ꤿȽꤹˤ:
 *		daʬλ齪ؤΥ٥ȥȤsᡢ
 *			0 <= s && s < 1
 *		ʤʬ˿롣
 *	* ºݤΰ q ˤ: q = a + da ꡢ
 *		s = mxv_point_to_line_s(p, a, da);
 *		mxv_vector_mul_1(das, da, s);
 *		mxv_vector_add(q, a, das);
 *	* ľؤεΥˤ: l = |pq| ꡢ
 *		mxv_vector_sub(pq, q, p);
 *		l = mxv_vector_magnitude(pq);
 */
float mxv_point_to_line_s(const MXVVECTOR* p, const MXVVECTOR* a, const MXVVECTOR* da);

/* ޷εҤ꤫꤫Ĵ٤ޤ
 * [in]
 *	points		޷ĺꥹ
 *	n_points	ĺο3̤ꤹȡȤޤ
 * [out]
 *			ʤ0ʳ֤ͤޤ
 *			ʤ0        ֤ޤ
 * [note]
 *	* ݥꥴˤбƤޤ
 *	* ɸϤϡX+Y+Ȥޤ
 *	  Ǥʤ硢ͤϵդΰ̣Ȥʤޤ
 */
int mxv_polygon_orientation(float points[/*n_points*/][2], int n_points);
#endif

#endif /*__CLIP_MATH_H__*/

