/*
 *	combo.c
 */
#include "app.h"

/****************************************************************************
 *	R{\^XN
 ****************************************************************************/

#define A(a,b,c,d,e,f)	a<<0|b<<1|c<<2|d<<3|e<<4|f<<5
static char pat_num[10][9] = {
	{ A(0,1,1,1,1,0),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(0,1,1,1,1,0) },
	{ A(0,0,1,1,0,0),
	  A(0,1,1,1,0,0),
	  A(0,0,1,1,0,0),
	  A(0,0,1,1,0,0),
	  A(0,0,1,1,0,0),
	  A(0,0,1,1,0,0),
	  A(0,0,1,1,0,0),
	  A(0,0,1,1,0,0),
	  A(0,1,1,1,1,0) },
	{ A(0,1,1,1,1,0),
	  A(1,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(0,0,0,0,1,1),
	  A(0,0,0,1,1,0),
	  A(0,1,1,0,0,0),
	  A(1,1,0,0,0,0),
	  A(1,1,0,0,0,0),
	  A(1,1,1,1,1,1) },
	{ A(0,1,1,1,1,0),
	  A(1,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(0,0,0,0,1,1),
	  A(0,0,1,1,1,0),
	  A(0,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(0,1,1,1,1,0) },
	{ A(0,0,0,0,1,1),
	  A(0,0,0,1,1,1),
	  A(0,0,1,0,1,1),
	  A(0,1,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(1,1,1,1,1,1),
	  A(0,0,0,0,1,1) },
	{ A(1,1,1,1,1,1),
	  A(1,1,0,0,0,0),
	  A(1,1,0,0,0,0),
	  A(1,1,0,0,0,0),
	  A(1,1,1,1,1,0),
	  A(0,0,0,0,1,1),
	  A(0,0,0,0,1,1),
	  A(0,0,0,0,1,1),
	  A(1,1,1,1,1,0) },
	{ A(0,1,1,1,1,0),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,0),
	  A(1,1,0,0,0,0),
	  A(1,1,1,1,1,0),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(0,1,1,1,1,0) },
	{ A(1,1,1,1,1,1),
	  A(0,0,0,0,1,1),
	  A(0,0,0,0,1,1),
	  A(0,0,0,1,1,0),
	  A(0,0,0,1,1,0),
	  A(0,0,0,1,1,0),
	  A(0,0,1,1,0,0),
	  A(0,0,1,1,0,0),
	  A(0,0,1,1,0,0) },
	{ A(0,1,1,1,1,0),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,1,1,1,0),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(1,1,0,0,0,1),
	  A(0,1,1,1,1,0) },
	{ A(0,1,1,1,1,0),
	  A(1,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(0,1,1,1,1,1),
	  A(0,0,0,0,1,1),
	  A(0,0,0,0,1,1),
	  A(1,0,0,0,1,1),
	  A(0,1,1,1,1,0) },
};
#undef A

typedef struct _TASKDATA {
	int combo;	/* R{ */
	int count;	/* Aj[VJE^ */
} TASKDATA;

static int
combo_work(TASK* task)
{
	TASKDATA* data = (TASKDATA*)(task + 1);

if(!pat_num) { }

	data->count++;
	if(data->count <= 5) {
		if(data->combo < 10) {
			bg_pattern(1, 4, 2, '0' + data->combo, CHR_TOFU4);
		} else {
			bg_pattern(1, 0, 2, '0' + data->combo / 10 % 10, CHR_TOFU4);
			bg_pattern(1, 8, 2, '0' + data->combo      % 10, CHR_TOFU4);
		}
		if(data->count & 1) {
			BSET(state, STATE_REVERSE);
		} else {
			BCLR(state, STATE_REVERSE);
		}
	} else {
		bg_clear(1);
		BCLR(state, STATE_REVERSE);
		return 0;
	}

	return 1;
}

TASK*
t_combo(int combo)
{
	TASK* task;
	TASKDATA* data;

	task = task_new(game_task, sizeof(TASKDATA));
	task->work = combo_work;

	data = (TASKDATA*)(task + 1);
	data->combo = combo;
	data->count = 0;

	return task;
}
